/*************************************************
*            BK Emulator for Window 3.0          *
*************************************************/

/*
File: BKDialog.h
Version: 1.0.0
Written by: Yuriy Kalmykov <kalmykov@stoik.com>
    Copyright (c) 2002-2004 Yuriy Kalmykov

    BK Emulator is a program emulated hardware environment for running
code for BK 0010(01) in different configurations. 
           
    This code may be used in compiled form in any way you desire.
This file or it's parts can't be redistributed without the authors
written consent, but can be modified for your private needs.
    Providing that this notice and the authors name and all copyright
notices remains intact.

    Please, an email me to know how you are using it and where. You can
ask me for any information about this below code or any attendant
knowledge.
    
    This file is provided "as is" with no expressed or implied warranty.
The author accepts no liability for any damage or loss of business that
this product may cause.
*/




#if !defined(AFX_BKDIALOG_H__EF832C99_5026_4084_9A9A_A1D5A2C40F67__INCLUDED_)
#define AFX_BKDIALOG_H__EF832C99_5026_4084_9A9A_A1D5A2C40F67__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// BKDialog.h : header file
//

#include "Bk.h"

/////////////////////////////////////////////////////////////////////////////
// CBKDialog dialog
/////////////////////////////////////////////////////////////////////////////
class CBKDialog : public CDialog
{
	static BOOL			bInit;
	static CFont		fontBK;
	
// Construction
public:
	CBKDialog(DWORD iID, CWnd* pParent = NULL);   // standard constructor
	~CBKDialog ();

	static void			InitializeBKFont ();
	static void			UninitializeBKFont ();
	static CFont*		GetBKFont ();
	static void			ChangeCommonDialogFont (HWND hDlg, HFONT hFont = NULL);
	static void			ChangeCommonDialogFont (CWnd* pDlg, CFont* pFont = NULL);

	BOOL				Create (int iTemplateName, CWnd* pParentWnd);

// Dialog Data
	//{{AFX_DATA(CBKDialog)
	enum { IDD = IDR_MAINFRAME };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBKDialog)
	public:
	virtual int DoModal();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	
	DWORD				m_dialogID;

	// Generated message map functions
	//{{AFX_MSG(CBKDialog)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BKDIALOG_H__EF832C99_5026_4084_9A9A_A1D5A2C40F67__INCLUDED_)
