/*************************************************
*            BK Emulator for Window 3.0          *
*************************************************/

/*
File: BKMainMenu.h
Version: 1.0.0
Written by: Yuriy Kalmykov <kalmykov@stoik.com>
    Copyright (c) 2002-2004 Yuriy Kalmykov

    BK Emulator is a program emulated hardware environment for running
code for BK 0010(01) in different configurations. 
           
    This code may be used in compiled form in any way you desire.
This file or it's parts can't be redistributed without the authors
written consent, but can be modified for your private needs.
    Providing that this notice and the authors name and all copyright
notices remains intact.

    Please, an email me to know how you are using it and where. You can
ask me for any information about this below code or any attendant
knowledge.
    
    This file is provided "as is" with no expressed or implied warranty.
The author accepts no liability for any damage or loss of business that
this product may cause.
*/




#if !defined(AFX_BKMAINMENU_H__578860B1_06C7_41AF_8A78_BD040B9712CC__INCLUDED_)
#define AFX_BKMAINMENU_H__578860B1_06C7_41AF_8A78_BD040B9712CC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// BKMainMenu.h : header file
//

#include "BKMenu.h"

/////////////////////////////////////////////////////////////////////////////
// CBKMainMenu window

#define WM_TRACK_NEXT_MENU (WM_USER + 101)

class CBKMainMenu : public CToolBarCtrl
{
	//static HHOOK		m_hHook;
	//static CBKMainMenu*	m_pThis;
	
	CMenu				m_menu;
	CBKMenu*			m_pSubMenus;
	int					m_nMenuButton;
	
	void				NormalizeState ();
	//BOOL				InstallHook ();
	//BOOL				UninstallHook ();
	void				TrackMenu (int nButton);
	int					NextMenu (CPoint pt);
	BOOL				LeaveMenu (CPoint pt);

	//static LRESULT CALLBACK HookProc (int code, WPARAM wParam, LPARAM lParam);
	

// Construction
public:
	CBKMainMenu();

// Attributes
public:

// Operations
public:
	BOOL				Create (int idMenu, CWnd* pParent);
	
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBKMainMenu)
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CBKMainMenu();

	// Generated message map functions
protected:
	//{{AFX_MSG(CBKMainMenu)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg HRESULT OnTrackNextMenu (WPARAM wParam, LPARAM lParam);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BKMAINMENU_H__578860B1_06C7_41AF_8A78_BD040B9712CC__INCLUDED_)
