/*************************************************
*            BK Emulator for Window 3.0          *
*************************************************/

/*
File: BKMessageBox.h
Version: 1.0.0
Written by: Yuriy Kalmykov <kalmykov@stoik.com>
    Copyright (c) 2002-2004 Yuriy Kalmykov

    BK Emulator is a program emulated hardware environment for running
code for BK 0010(01) in different configurations. 
           
    This code may be used in compiled form in any way you desire.
This file or it's parts can't be redistributed without the authors
written consent, but can be modified for your private needs.
    Providing that this notice and the authors name and all copyright
notices remains intact.

    Please, an email me to know how you are using it and where. You can
ask me for any information about this below code or any attendant
knowledge.
    
    This file is provided "as is" with no expressed or implied warranty.
The author accepts no liability for any damage or loss of business that
this product may cause.
*/




// BKMessageBox.h: interface for the CBKMessageBox class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BKMESSAGEBOX_H__C876EBDE_0718_4D5D_B750_C7C601607886__INCLUDED_)
#define AFX_BKMESSAGEBOX_H__C876EBDE_0718_4D5D_B750_C7C601607886__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CBKMessageBox  
{
	static HHOOK		m_hHook;
	static CBKMessageBox*	m_pThis;
	
	BOOL				InstallHook ();
	BOOL				UninstallHook ();

	static LRESULT CALLBACK HookProc (int code, WPARAM wParam, LPARAM lParam);
	
public:
	CBKMessageBox ();
	CBKMessageBox (LPCTSTR lpszText, UINT nType = MB_OK, UINT nIDHelp = 0);
	virtual ~CBKMessageBox();

	int					Show (LPCTSTR lpszText, UINT nType = MB_OK, UINT nIDHelp = 0);
	int					Show (UINT strID, UINT nType = MB_OK, UINT nIDHelp = 0);
};

#endif // !defined(AFX_BKMESSAGEBOX_H__C876EBDE_0718_4D5D_B750_C7C601607886__INCLUDED_)
