/*************************************************
*            BK Emulator for Window 3.0          *
*************************************************/

/*
File: DebugAddressDlg.cpp
Version: 1.0.0
Written by: Yuriy Kalmykov <kalmykov@stoik.com>
    Copyright (c) 2002-2004 Yuriy Kalmykov

    BK Emulator is a program emulated hardware environment for running
code for BK 0010(01) in different configurations. 
           
    This code may be used in compiled form in any way you desire.
This file or it's parts can't be redistributed without the authors
written consent, but can be modified for your private needs.
    Providing that this notice and the authors name and all copyright
notices remains intact.

    Please, an email me to know how you are using it and where. You can
ask me for any information about this below code or any attendant
knowledge.
    
    This file is provided "as is" with no expressed or implied warranty.
The author accepts no liability for any damage or loss of business that
this product may cause.
*/




// DebugAddressDlg.cpp : implementation file
//

#include "stdafx.h"
#include "bk.h"
#include "DebugAddressDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDebugAddressDlg dialog


CDebugAddressDlg::CDebugAddressDlg(CWnd* pParent /*=NULL*/)
	: CBKDialog(CDebugAddressDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDebugAddressDlg)
	m_debug_address = _T("");
	m_dump_address = _T("");
	//}}AFX_DATA_INIT
}


void CDebugAddressDlg::DoDataExchange(CDataExchange* pDX)
{
	CBKDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDebugAddressDlg)
	DDX_Text(pDX, IDC_DA_DUMP_ADDRESS, m_dump_address);
	DDX_Text(pDX, IDC_DA_DEBUG_ADDRESS, m_debug_address);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDebugAddressDlg, CBKDialog)
	//{{AFX_MSG_MAP(CDebugAddressDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDebugAddressDlg message handlers

BOOL CDebugAddressDlg::OnInitDialog() 
{
	CBKDialog::OnInitDialog();
	
	m_old_debug_address = m_debug_address;
	m_old_dump_address = m_dump_address;
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
