/*************************************************
*            BK Emulator for Window 3.0          *
*************************************************/

/*
File: PanelSplitter.h
Version: 1.0.0
Written by: Yuriy Kalmykov <kalmykov@stoik.com>
    Copyright (c) 2002-2004 Yuriy Kalmykov

    BK Emulator is a program emulated hardware environment for running
code for BK 0010(01) in different configurations. 
           
    This code may be used in compiled form in any way you desire.
This file or it's parts can't be redistributed without the authors
written consent, but can be modified for your private needs.
    Providing that this notice and the authors name and all copyright
notices remains intact.

    Please, an email me to know how you are using it and where. You can
ask me for any information about this below code or any attendant
knowledge.
    
    This file is provided "as is" with no expressed or implied warranty.
The author accepts no liability for any damage or loss of business that
this product may cause.
*/




// PanelWithSplitter.h: interface for the CPanelWithSplitter class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PANELSPLITTER_H__708DAA0D_324B_45C3_B7A9_3CE343608492__INCLUDED_)
#define AFX_PANELSPLITTER_H__708DAA0D_324B_45C3_B7A9_3CE343608492__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//////////////////////////////////////////////////////////////////////
#include "Panel.h"
#include "Splitter.h"

//////////////////////////////////////////////////////////////////////
#define DEFAULT_SPLITTER_WIDTH 6

//////////////////////////////////////////////////////////////////////
class CPanelSplitter : public CPanel  
{
private:
	CSplitter			m_splitter;							// Internal splitter window

protected:
	virtual void		OnSetAlign (int align);				// Called after panel has been attached
	virtual void		OnDraw (CDC* pDC, CRect& rcBound);	// Method for draw panel
	virtual void		OnRecalcWindowsZorder ();			// Called for reposition panel windows by z-order
	
public:
	
	CPanelSplitter (CWnd* pParent);
	virtual ~CPanelSplitter ();
};

#endif // !defined(AFX_PANELSPLITTER_H__708DAA0D_324B_45C3_B7A9_3CE343608492__INCLUDED_)
